#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire600eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight6004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight6004xi = {
                1:'-101x-121y-578z',
                2:'-105x-403y-431z',
                3:'-106x-586y-65z',
                4:'-107x-207y-552z',
                5:'-112x-120y-576z',
                6:'-117x-459y-367z',
                7:'-11x-93y-592z',
                8:'-121x-206y-550z',
                9:'-122x-118y-575z',
                10:'-128x-401y-427z',
                11:'-132x-115y-573z',
                12:'-135x-204y-547z',
                13:'-136x-581y-59z',
                14:'-13x-593y-83z',
                15:'-142x-455y-363z',
                16:'-143x-112y-571z',
                17:'-148x-201y-545z',
                18:'-150x-397y-423z',
                19:'-153x-107y-569z',
                20:'-162x-197y-542z',
                21:'-163x-102y-568z',
                22:'-167x-451y-358z',
                23:'-167x-573y-53z',
                24:'-172x-393y-418z',
                25:'-173x-96y-566z',
                26:'-176x-193y-540z',
                27:'-17x-98y-591z',
                28:'-183x-90y-564z',
                29:'-18x-398y-447z',
                30:'-18x-458y-386z',
                31:'-190x-187y-537z',
                32:'-192x-445y-353z',
                33:'-193x-82y-561z',
                34:'-194x-387y-414z',
                35:'-197x-564y-47z',
                36:'-1x-82y-594z',
                37:'-202x-74y-559z',
                38:'-203x-180y-534z',
                39:'-211x-65y-557z',
                40:'-216x-173y-531z',
                41:'-216x-380y-410z',
                42:'-216x-437y-348z',
                43:'-220x-55y-555z',
                44:'-226x-553y-41z',
                45:'-228x-44y-553z',
                46:'-230x-164y-529z',
                47:'-235x-33y-550z',
                48:'-238x-371y-405z',
                49:'-23x-103y-590z',
                50:'-241x-428y-343z',
                51:'-242x-155y-526z',
                52:'-242x-21y-548z',
                53:'-255x-144y-523z',
                54:'-255x-541y-35z',
                55:'-25x-226y-662z',
                56:'-260x-362y-401z',
                57:'-265x-418y-338z',
                58:'-267x-133y-520z',
                59:'-278x-121y-517z',
                60:'-281x-351y-396z',
                61:'-283x-527y-29z',
                62:'-288x-406y-333z',
                63:'-289x-108y-514z',
                64:'-299x-94y-511z',
                65:'-301x-338y-392z',
                66:'-308x-80y-508z',
                67:'-30x-107y-589z',
                68:'-311x-393y-328z',
                69:'-311x-512y-23z',
                70:'-322x-325y-387z',
                71:'-32x-197y-565z',
                72:'-333x-379y-323z',
                73:'-337x-495y-17z',
                74:'-341x-310y-383z',
                75:'-355x-363y-318z',
                76:'-360x-294y-378z',
                77:'-363x-477y-11z',
                78:'-376x-346y-313z',
                79:'-378x-277y-373z',
                80:'-387x-457y-5z',
                81:'-38x-111y-588z',
                82:'-395x-259y-369z',
                83:'-396x-328y-308z',
                84:'-40x-401y-443z',
                85:'-411x-240y-364z',
                86:'-411x-436y0z',
                87:'-415x-309y-303z',
                88:'-426x-220y-359z',
                89:'-433x-288y-298z',
                90:'-43x-460y-381z',
                91:'-440x-199y-354z',
                92:'-44x-201y-563z',
                93:'-44x-593y-77z',
                94:'-450x-266y-292z',
                95:'-454x-177y-349z',
                96:'-466x-154y-345z',
                97:'-466x-244y-287z',
                98:'-46x-114y-587z',
                99:'-476x-130y-340z',
                100:'-481x-220y-282z',
                101:'-486x-106y-335z',
                102:'-494x-196y-276z',
                103:'-494x-80y-330z',
                104:'-501x-55y-325z',
                105:'-506x-171y-271z',
                106:'-517x-145y-266z',
                107:'-527x-118y-260z',
                108:'-54x-117y-585z',
                109:'-56x-204y-561z',
                110:'-5x-88y-593z',
                111:'-61x-403y-439z',
                112:'-63x-119y-584z',
                113:'-67x-461y-377z',
                114:'-68x-206y-559z',
                115:'-72x-121y-583z',
                116:'-75x-590y-71z',
                117:'-81x-207y-556z',
                118:'-82x-122y-581z',
                119:'-83x-403y-435z',
                120:'-91x-122y-580z',
                121:'-92x-461y-372z',
                122:'-94x-208y-554z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire600eight4xi" usage = "target function for charge600eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire600eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE600EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE600EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE600EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE600EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE600EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight6004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE600EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE600EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE600EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight6004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight6004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE600EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE600EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE600EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire600eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  